local _G = _G;
local GetTime = GetTime
local string, ipairs = string, ipairs
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch, string_length, string_sub, math_floor= print, string.format, string.gmatch, string.len, string.sub, math.floor
local red = RED_FONT_COLOR
red.r, red.g, red.b = 0.75, 0.05 ,0.05
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local UnrealTargets_options = {};
local newtabs = true

function UnrealTargets:mysettings(arg1)
	--print (arg1.." loaded")
	if arg1 == "UnrealTargets" then
	   if not unrealtargetssettings then
			unrealtargetssettings = {
				['config'] = {
					['height'] = 15,
					['width'] = 150,
					['rafter_distance'] = 5,
					['posix'] = 300,
					['posiy'] = 0,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
				}
			}
			--print('ut 1')
		elseif unrealtargetssettings == nil then
			unrealtargetssettings  = {
				['config'] = {
					['height'] = 15,
					['width'] = 150,
					['rafter_distance'] = 5,
					['posix'] = 300,
					['posiy'] = 0,
					['color_r'] = 0.75,
					['color_g'] = 0.05,
					['color_b'] = 0.05,
					['color_a'] = 1,
				}
			}
			--print('ut 2')
		else
			--print (unrealtargetssettings['config']['height'].." 45")
		end
	end
end

local unitdb = {}
unitdb.isinfight = false
unitdb.allunitguids = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}
unitdb.slider = 0
local myunits = {}
myunits.castTime = 0

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- allunitguids
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	,69791 -- Feuergeist
	,59390 -- Spottendes Banner
	,48638 -- Schlachtstandarte der Gilde
	,84774 -- Tödliche Eisenfalle
	,83925 -- Eisenfalle
	,44199 -- Ring des Frosts
	,77894 -- Walter
	,95468 -- Satyr der Illidari
	,95469 -- Bösartiger Höllenhund
	,86951 -- Wolf aus Nagrand
	,86187 -- Tier
	,65282 -- Leerententakel
	,61712 -- Feuertotem
	,56194 -- Spinnenjungtier
	,90206 -- Schwester der Versuchung
	,93247 -- Dämonenportal
	,62005 -- Tier
	,33239 -- El Jonathanxd
	,86702 -- Verweilender Geist
	}

	--,93713 -- Klingenmeister Jubei'thos (5%!!!!!!!!!
	-- ,93298 -- Schattenherzunhold
	
-- 90432 FAIL	
	

	
function cmdut(arg)
	
	if arg == "test" then
		
	elseif  arg == "test2" then
		
	elseif  arg == "reset" then
		UnrealTargets:reset_frames()
	end	
end

function UnrealTargets:option_slider(name, uiparent, anocher, posix, posiy, minvale, maxvalue, titlename, databasevalue) 
	local slider = CreateFrame("Slider", name ,uiparent,"OptionsSliderTemplate")
	slider:SetPoint(anocher, posix, posiy)
	slider.textLow = _G[name.."Low"]
	slider.textHigh = _G[name.."High"]
	slider.text = _G[name.."Text"]
	slider:SetMinMaxValues(minvale, maxvalue)
	slider.minValue, slider.maxValue = slider:GetMinMaxValues() 
	slider.textLow:SetText(slider.minValue)
	slider.textHigh:SetText(slider.maxValue)
	slider.text:SetText(titlename)
	slider:SetValue(databasevalue)
	slider:SetValueStep(1)
	
	slider.editBox = CreateFrame("EditBox", "edittest"..name, slider, "InputBoxTemplate")
	slider.editBox:SetWidth(30)
	slider.editBox:SetHeight(8)
	--slider.editBox:SetFontObject(GameFontNormal)
	--slider.editBox:SetBackdrop(GameTooltip:GetBackdrop())
	slider.editBox:SetBackdropColor(0, 0, 0, 0.8)
	slider.editBox:SetBackdropBorderColor(0.6, 0.6, 0.6, 1)
	slider.editBox:SetPoint("Topleft", 62, -20)
	slider.editBox:ClearFocus(self)
	slider.editBox:SetAutoFocus(false)	
	return slider
end

function round(num, ...)
	local idp = ... or 0
	local mult = 10^(idp or 0)
	return math_floor(num * mult + 0.5) / mult
end

function UnrealTargets:set_hp_frame(posix, posiy, ...)
	local framename, uiparent = ... or nil, UiParent
	local NewStatusBar = CreateFrame("StatusBar", nil, uiparent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(unrealtargetssettings['config']['width'])
	NewStatusBar:SetHeight(unrealtargetssettings['config']['height'])
	NewStatusBar:SetPoint("CENTER",posix, posiy)
	NewStatusBar:SetStatusBarColor(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'])
	return NewStatusBar
end

SlashCmdList["cmdut"] = cmdut; 
SLASH_cmdut1 = "/utar";
SLASH_cmdut2 = "/UnrealTargets";
SLASH_cmdut3 = "/unrealtargets";
SLASH_cmdut4 = "/unrealtarget";
unitdb.slider ={}

UnrealTargets_options = {};
UnrealTargets_options.panel = CreateFrame("ScrollFrame", "UnrealTargetsPanel", UIParent );
UnrealTargets_options.panel.name = "UnrealTargets";
UnrealTargets_options.panel.okay = 
function (self)
	self.originalValue = MY_VARIABLE;
end
InterfaceOptions_AddCategory(UnrealTargets_options.panel)

local function showColorPicker(r,g,b,a,callback)
  ColorPickerFrame:SetColorRGB(r,g,b)
  ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a
  ColorPickerFrame.previousValues = {r,g,b,a}
  ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = callback, callback, callback
  ColorPickerFrame:Hide() -- Need to run the OnShow handler.
  ColorPickerFrame:Show()
end
 
local function create_color_template(posix, posiy)
	--frame
	local f = CreateFrame("FRAME" ,"barcolor" , UnrealTargetsPanel)
	f:SetSize(15,15)
	f:SetPoint("TOPLEFT", posix, posiy)
	--texture
	f.tex = f:CreateTexture(nil,"BACKGROUND",nil,-7)
	f.tex:SetAllPoints(f)
	f.tex:SetTexture(unrealtargetssettings['config']['color_r'],
		unrealtargetssettings['config']['color_g'],
		unrealtargetssettings['config']['color_b'],
		unrealtargetssettings['config']['color_a'])
	--recolor callback function
	f.recolorTexture = function(color)
		local r,g,b,a
		if color then
			r,g,b,a = unpack(color)
		else
			r,g,b = ColorPickerFrame:GetColorRGB()
			a = OpacitySliderFrame:GetValue()
			--print("new? "..r.." "..g.." "..b)
			unrealtargetssettings['config']['color_r'] = r
			unrealtargetssettings['config']['color_g'] = g
			unrealtargetssettings['config']['color_b'] = b
			unrealtargetssettings['config']['color_a'] = a
		end
		
		f.tex:SetTexture(r, g, b, a)
	end
	f:EnableMouse(true)
	f:SetScript("OnMouseDown", function(self,button,...)
		if button == "LeftButton" then
			local r,g,b,a = self.tex:GetVertexColor()
			showColorPicker(r,g,b,a,self.recolorTexture)
		end
	end)
	return f
end



unitdb.header1 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
unitdb.header1:SetPoint("Topleft",200, -40)
unitdb.header1:SetText("Bar Options")
unitdb.header1:SetFont("Fonts\\FRIZQT__.ttf",18,"OUTLINE")
unitdb.header1:SetTextColor(red.r, red.g, red.b)
unitdb.header2 = UnrealTargets_options.panel:CreateFontString(nil, "OVERLAY", "GameTooltipText")
unitdb.header2:SetPoint("Topleft",35, -202)
unitdb.header2:SetText("Color")
unitdb.header2:SetFont("Fonts\\FRIZQT__.ttf",12,"OUTLINE")




function UnrealTargets:Initialize()
	local value2 = unrealtargetssettings['config']['height']
	local barcolor = create_color_template(15, -200)
	local name = "resetbutton"
	local template = "UIPanelButtonTemplate"
	local button = CreateFrame("Button", name, UnrealTargetsPanel, "UIPanelButtonTemplate") --frameType, frameName, frameParent, frameTemplate    
	button:SetSize(50,15)
	button:SetPoint("Topleft",10, -10)
	button.text = _G[name.."Text"]
	button.text:SetText("Reset")
	button:SetScript("OnClick", function(self, ...) 
		print("reset options")
		unrealtargetssettings['config']['height'] = 25
		unrealtargetssettings['config']['width'] = 150
		unrealtargetssettings['config']['rafter_distance'] = 5
		unrealtargetssettings['config']["posix"] = 300
		unrealtargetssettings['config']["posiy"] = 0
		unrealtargetssettings['config']['color_r'] = 0.75
		unrealtargetssettings['config']['color_g'] = 0.05
		unrealtargetssettings['config']['color_b'] = 0.05
		unrealtargetssettings['config']['color_a'] = 1
		unitdb.slider.height:SetValue(unrealtargetssettings['config']['height'])
		unitdb.slider.width:SetValue(unrealtargetssettings['config']['width'])
		unitdb.slider.rafter_distance:SetValue(unrealtargetssettings['config']['rafter_distance'])
		unitdb.slider.posix:SetValue(unrealtargetssettings['config']["posix"])
		unitdb.slider.posiy:SetValue(unrealtargetssettings['config']["posiy"])
		barcolor.tex:SetTexture(1, 0.1, 0.1, 1)
	end)

	unitdb.slider.height = UnrealTargets:option_slider('height', UnrealTargetsPanel, "TOPLEFT", 10, -80, 4, 50, 'height', unrealtargetssettings['config']['height'])
	unitdb.slider.height:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['height'] = event
		unitdb.slider.height.editBox:SetText(event)
	end)
	unitdb.slider.height.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.height.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['height']
		if value > 50 then
			value = 50
		elseif value < 4 then
			value = 4
		end
		unitdb.slider.height.editBox:SetText(value)
		unrealtargetssettings['config']['height'] = value
		unitdb.slider.height:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.height.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.height.editBox:SetText(unrealtargetssettings['config']['height'])
		self:ClearFocus()
	end)

	unitdb.slider.width = UnrealTargets:option_slider('width', UnrealTargetsPanel, "TOPLEFT", 185, -80, 25, 500, 'width', unrealtargetssettings['config']['width'])
	unitdb.slider.width:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['width'] = event
		unitdb.slider.width.editBox:SetText(event)
	end)
	unitdb.slider.width.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.width.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['width']
		if value > 500 then
			value = 500
		elseif value < 25 then
			value = 25
		end
		unitdb.slider.width.editBox:SetText(value)
		unrealtargetssettings['config']['width'] = value
		unitdb.slider.width:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.width.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.width.editBox:SetText(unrealtargetssettings['config']['width'])
		self:ClearFocus()
	end)

	unitdb.slider.rafter_distance = UnrealTargets:option_slider('rafter_distance', UnrealTargetsPanel, "TOPLEFT", 360, -80, 0, 25, "Bar-Distance", unrealtargetssettings['config']['rafter_distance'])
	unitdb.slider.rafter_distance:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']['rafter_distance'] = event
		unitdb.slider.rafter_distance.editBox:SetText(event)
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.rafter_distance.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']['rafter_distance']
		if value > 25 then
			value = 25
		elseif value < 0 then
			value = 0
		end
		unitdb.slider.rafter_distance.editBox:SetText(value)
		unrealtargetssettings['config']['rafter_distance'] = value
		unitdb.slider.rafter_distance:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.rafter_distance.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.rafter_distance.editBox:SetText(unrealtargetssettings['config']['rafter_distance'])
		self:ClearFocus()
	end)

	unitdb.slider.posix = UnrealTargets:option_slider("posix", UnrealTargetsPanel, "TOPLEFT", 10, -140, -1000, 1000, "X-position", unrealtargetssettings['config']["posix"])
	unitdb.slider.posix:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["posix"] = event
		unitdb.slider.posix.editBox:SetText(event)
	end)
	unitdb.slider.posix.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.posix.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["posix"]
		if value > 1000 then
			value = 1000
		elseif value < -1000 then
			value = -1000
		end
		unitdb.slider.posix.editBox:SetText(value)
		unrealtargetssettings['config']["posix"] = value
		unitdb.slider.posix:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.posix.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.posix.editBox:SetText(unrealtargetssettings['config']["posix"])
		self:ClearFocus()
	end)

	unitdb.slider.posiy = UnrealTargets:option_slider("posiy", UnrealTargetsPanel, "TOPLEFT", 185, -140, -1000, 1000, "Y-position", unrealtargetssettings['config']["posiy"])
	unitdb.slider.posiy:SetScript("OnValueChanged", function(self,event,arg1) 
		event = round(event)
		self:SetValue(event)
		unrealtargetssettings['config']["posiy"] = event
		unitdb.slider.posiy.editBox:SetText(event)
	end)
	unitdb.slider.posiy.editBox:SetScript( "OnEnterPressed", function(self) 
		local value = unitdb.slider.posiy.editBox:GetText()
		value = tonumber(value) or unrealtargetssettings['config']["posiy"]
		if value > 1000 then
			value = 1000
		elseif value < -1000 then
			value = -1000
		end
		unitdb.slider.posiy.editBox:SetText(value)
		unrealtargetssettings['config']["posiy"] = value
		unitdb.slider.posiy:SetValue(value)
		self:ClearFocus()		
	end)
	unitdb.slider.posiy.editBox:SetScript( "OnEscapePressed", function(self)
		unitdb.slider.posiy.editBox:SetText(unrealtargetssettings['config']["posiy"])
		self:ClearFocus()
	end)

	
	-- myunits.bar = UnrealTargets:set_hp_frame(0, 0, 'mytestbar', UiParent)
	-- local testheightbar = 33
	-- local testwidthbar = 200
	-- myunits.bar:SetWidth(testwidthbar)
	-- myunits.bar:SetHeight(testheightbar)
	-- myunits.fontname = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fontname:SetPoint("TOPLEFT", 0, 0)
	-- local targetname = UnrealTargets:cut_name("testabcdefghijklmnopqrstuvwxyz")
	-- myunits.fontname:SetText(targetname)
	-- myunits.fontname:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")
	-- myunits.fonthppercent = myunits.bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	-- myunits.fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	-- myunits.fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",testheightbar*20/33,"OUTLINE")	
	-- myunits.bar:SetMovable(true)
	-- myunits.bar:EnableMouse(true)
	-- myunits.bar:RegisterForDrag("LeftButton")
	-- myunits.bar:SetScript("OnDragStart", myunits.bar.StartMoving)
	-- myunits.bar:SetScript("OnDragStop", myunits.bar.StopMovingOrSizing)
	-- myunits.castbar = UnrealTargets:set_hp_frame(0, -testheightbar/3, 'mytestbarcastline', myunits.bar)
	-- myunits.castbar:SetWidth(testwidthbar)
	-- myunits.castbar:SetHeight(testheightbar/3)
	-- myunits.castbar:SetStatusBarColor(1,0,1)
	-- myunits.castbar:Hide()
	-- local icon = select(3,GetSpellInfo(740))
	-- myunits.icon = CreateFrame("StatusBar", 'mytestbaricon', myunits.bar)
	-- myunits.icon:SetStatusBarTexture(icon)
	-- myunits.icon:SetWidth(testheightbar)
	-- myunits.icon:SetHeight(testheightbar)
	-- myunits.icon:SetPoint("Topleft", -testheightbar, 0)
	-- myunits.icon:Hide()
end



function UnrealTargets:frequently_frame_update(...)
	guid = UnitGUID(...)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
	local max_health = UnitHealthMax(...)
	local currenthealth = UnitHealth(...)
	if max_health ~= 0 and currenthealth ~= 0 then
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
	for k, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
			local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
			health = string_format("%.0f", health)
			unitdb.units[destGUID].bar:SetValue(health)
			health = health.."%"
			unitdb.units[destGUID].fonthppercent:SetText(health)
		end
	end
end

function UnrealTargets:frame_update(time, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local type, _, _, _, _, npc_id, _ = strsplit("-",destGUID)
	local sourcetype = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false
	local ignornpcid = false
	-- if event == "SPELL_CAST_START" then
		-- local _, _, spellID, spellname = ...
		-- _, _, _, myunits.castTime = GetSpellInfo(spellID)
		-- local icon = select(3,GetSpellInfo(spellID))
		-- myunits.icon:Show()
		-- myunits.icon:SetStatusBarTexture(icon)
		-- myunits.castbar:Show()
		-- myunits.castTime =  myunits.castTime/1000
		-- myunits.castTimeend = myunits.castTime + GetTime()
		-- --print('cast start '..spellname..' '..myunits.castTime)
	-- end
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitguid == destGUID then
			if unit ~= "player" then
				if event == "UNIT_DIED" then
					table_remove(unitdb.allunitguids, i)
					unitdb.units[unitguid].bar:Hide()
					unitdb.units[unitguid].castbar:Hide()
					for j, upunitguid in ipairs(unitdb.allunitguids) do
						unitdb.units[upunitguid].bar:SetPoint("CENTER",unrealtargetssettings['config']["posix"], unrealtargetssettings['config']["posiy"]-(j-1)*(unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']))
					end
				elseif event == "SWING_DAMAGE" then
					_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				elseif event == "SPELL_PERIODIC_DAMAGE" then
					_,_,_,_,_, dmg = ...
					self:hp_update(destGUID, dmg)
				end
			end
			isindb = true
		elseif unitguid == srcGUID then
			 if event == 'SPELL_CAST_START' then
				local _, _, spellID, spellname, spellSchool = ...
				_, _, _, unitdb.units[srcGUID].castTime = GetSpellInfo(spellID)
				local castname, _, icon = GetSpellInfo(spellID)
				castname = self:cut_name(castname, 13)
				unitdb.units[srcGUID].castbar_fontname:SetText(castname)
				unitdb.units[srcGUID].icon:Show()
				unitdb.units[srcGUID].icon:SetStatusBarTexture(icon)
				unitdb.units[srcGUID].castbar:Show()
				unitdb.units[srcGUID].castTime =  unitdb.units[srcGUID].castTime/1000
				unitdb.units[srcGUID].castTimeend = unitdb.units[srcGUID].castTime + GetTime()
				local castcolor = {}
				castcolor.r, castcolor.g, castcolor.b = UnrealTargets:get_spellschool_color_code(spellSchool)
				unitdb.units[srcGUID].castbar:SetStatusBarColor(castcolor.r, castcolor.g, castcolor.b)
				--print('cast start '..spellname..' '..unitdb.units[srcGUID].castTime)
			end
		end
		
	end
	if not isindb then
		if type == "Creature" and sourcetype == "Player" or type == "Vehicle" and sourcetype == "Player"then
			if unitdb.isinfight == true then
				ignornpcid = self:ignor_npc(npc_id)
				if ignornpcid == false then
					SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
					table_insert(unitdb.allunitguids, destGUID)
					unitdb.units[destGUID] = {}
					if unitdb.unitsmaxhp[npc_id] then
						unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
					else
						unitdb.units[destGUID].maxhp = 1000000
					end
					unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp
					unitdb.units[destGUID].npcid = npc_id
					unitdb.units[destGUID].bar = UnrealTargets:set_hp_frame(unrealtargetssettings['config']["posix"], unrealtargetssettings['config']["posiy"]-table_getn(unitdb.allunitguids)*(unrealtargetssettings['config']['rafter_distance']+unrealtargetssettings['config']['height']),'bar'..destGUID ,UiParent)
					unitdb.units[destGUID].bar:SetWidth(unrealtargetssettings['config']['width'])
					unitdb.units[destGUID].bar:SetHeight(unrealtargetssettings['config']['height'])
					unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fontname:SetPoint("TOPLEFT", 1, -1)
					local targetname = self:cut_name(destName)
					unitdb.units[destGUID].fontname:SetText(targetname)
					unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/2,"OUTLINE")
					unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fonthppercent:SetPoint("TOPRIGHT", -1, -1)
					unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/2,"OUTLINE")
					
					unitdb.units[destGUID].castbar = UnrealTargets:set_hp_frame(0,0, 'castbar'..destGUID, unitdb.units[destGUID].bar)
					unitdb.units[destGUID].castbar:SetPoint('CENTER', unitdb.units[destGUID].bar, 'CENTER', 0, -unrealtargetssettings['config']['height']/3)
					unitdb.units[destGUID].castbar:SetWidth(unrealtargetssettings['config']['width'])
					unitdb.units[destGUID].castbar:SetHeight(unrealtargetssettings['config']['height']/3)
					unitdb.units[destGUID].castbar:SetStatusBarColor(0,0,0)
					unitdb.units[destGUID].castbar:Hide()
					local castname, _, icon = GetSpellInfo(740)
					unitdb.units[destGUID].icon = CreateFrame("StatusBar", 'bar'..destGUID, unitdb.units[destGUID].bar)
					unitdb.units[destGUID].icon:SetStatusBarTexture(icon)
					unitdb.units[destGUID].icon:SetWidth(unrealtargetssettings['config']['height'])
					unitdb.units[destGUID].icon:SetHeight(unrealtargetssettings['config']['height'])
					unitdb.units[destGUID].icon:SetPoint("Topleft", -unrealtargetssettings['config']['height'], 0)
					unitdb.units[destGUID].icon:Hide()
					unitdb.units[destGUID].castTime = 0
					unitdb.units[destGUID].castbar_fontname = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].castbar_fontname:SetPoint("TOPLEFT", 1, -1)
					castname = self:cut_name(castname, 18)
					unitdb.units[destGUID].castbar_fontname:SetText(castname)
					unitdb.units[destGUID].castbar_fontname:SetFont("Fonts\\FRIZQT__.ttf", unrealtargetssettings['config']['height']/3-1,"OUTLINE")
					unitdb.units[destGUID].castbartime = unitdb.units[destGUID].castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].castbartime:SetPoint("TOPRIGHT", -1, -1)
					unitdb.units[destGUID].castbartime:SetFont("Fonts\\FRIZQT__.ttf",unrealtargetssettings['config']['height']/3-1,"OUTLINE")
					
				end
			end
		end
	end
end

function UnrealTargets:get_spellschool_color_code(colorcode)
	local color = {}
	if colorcode == 1 then
		color.r, color.g ,color.b = 1,1,0
	else
		color.r, color.g ,color.b = 1, 0.1, 0.1
	end
	return color.r, color.g ,color.b
end

function UnrealTargets:cut_name(name, ...)
	local max_length = ... or 18
	local length = string_length(name)
	if length > max_length + 2 then
		name = string_sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

function UnrealTargets:ignor_npc(npc_id)
	for i, unitid in ipairs(unitdb.ignornpc) do
		if tonumber(npc_id) == unitid then
			return true
		end
	end
	return false
end

function UnrealTargets:hp_update(destGUID, dmg)
	unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
	local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
	health = string_format("%.0f", health)
	unitdb.units[destGUID].bar:SetValue(health)
	health = health.."%"
	unitdb.units[destGUID].fonthppercent:SetText(health)
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.allunitguids) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
				if npc_id == unitdb.units[unitguid].npcid then
					local deltahp = unitdb.units[unitguid].maxhp - unitdb.units[unitguid].hp 
					unitdb.units[unitguid].maxhp = max_health
					unitdb.units[unitguid].hp = unitdb.units[unitguid].maxhp -deltahp
					self:hp_update(unitguid, 0)
				end		
			end
		end
	end
end

function UnrealTargets:reset_frames()
	for k, unitguid in ipairs(unitdb.allunitguids) do
		unitdb.units[unitguid].bar:Hide()
		unitdb.units[unitguid].castbar:Hide()
		unitdb.units[unitguid] = {}
		table_remove(unitdb.allunitguids, 0)
	end
	unitdb.allunitguids = {}
	unitdb.units = {}
end

-- function UnrealTargets:unit_target(...)
	-- local arg1 = ... or "player"
	-- local sourcename = UnitName(arg1)
	-- local name = UnitName(arg1.."target") or "no target"
	-- print(sourcename..": "..name)
-- end

-- function UnrealTargets:unit_mouseover(...)
	-- local arg1 = ... or "player"
	-- local sourcename = UnitName(arg1)
	-- local name = UnitName(arg1.."target")
	-- print("mouseover "..sourcename..": "..name)
-- end

UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	-- if myunits.castTime ~= 0 then
		-- local value = myunits.castTimeend - GetTime()
		-- if value >= 0 then
			-- local value2 = value/myunits.castTime
			-- myunits.castbar:SetValue((1-value2)*100)
			-- --print(value2)
		-- else
			-- myunits.castTime = 0
			-- myunits.castbar:Hide()
			-- myunits.icon:Hide()
		-- end
	-- end
	for i, unitguid in ipairs(unitdb.allunitguids) do
		if unitdb.units[unitguid].castTime ~= 0 then
			local remaining_time = unitdb.units[unitguid].castTimeend - GetTime()
			if remaining_time >= 0 then
				local value2 = remaining_time/unitdb.units[unitguid].castTime
				unitdb.units[unitguid].castbar:SetValue((1-value2)*100)
				unitdb.units[unitguid].castbar:Show()
				unitdb.units[unitguid].icon:Show()
				remaining_time = string_format("%.1f", remaining_time)
				unitdb.units[unitguid].castbartime:SetText(remaining_time)
				--print(value2..' new? '..unitguid)
			else
				unitdb.units[unitguid].castTime = 0
				unitdb.units[unitguid].castbar:Hide()
				unitdb.units[unitguid].icon:Hide()
			end
		end
	end
	--print(mytime)
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		self:Initialize(...)
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:frame_update(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'ENCOUNTER_END' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'PLAYER_REGEN_ENABLED' then
		self:reset_frames()
		unitdb.isinfight = false
	elseif event == 'ENCOUNTER_START' then
		unitdb.isinfight = true
	elseif event == 'PLAYER_REGEN_DISABLED' then
		unitdb.isinfight = true
	elseif event == 'ADDON_LOADED' then
		self:mysettings(...)
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		self:frequently_frame_update(...)
	-- elseif event == 'UNIT_TARGET' then
		-- self:unit_target(...)
	-- elseif event == 'UPDATE_MOUSEOVER_UNIT' then
		-- self:unit_mouseover(...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end



UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:RegisterEvent('ENCOUNTER_END')
UnrealTargets:RegisterEvent('PLAYER_REGEN_ENABLED')
UnrealTargets:RegisterEvent('ENCOUNTER_START')
UnrealTargets:RegisterEvent('ADDON_LOADED')
--UnrealTargets:RegisterEvent('UNIT_TARGET')
--UnrealTargets:RegisterEvent('UPDATE_MOUSEOVER_UNIT')
UnrealTargets:RegisterEvent('PLAYER_REGEN_DISABLED')
UnrealTargets:SetScript('OnEvent', OnEvent)



